/*######     Copyright (c) 1997-2012 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com    ##########################################
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published #
# by the Free Software Foundation; either version 3, or (at your option) any later version. This program is distributed in the hope that #
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. #
# See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this #
# program; If not, see <http://www.gnu.org/licenses/>                                                                                    #
########################################################################################################################################*/
#pragma warning(disable : 4731)

/*!!!R
void ImpAddBignums(const BASEWORD *a, const BASEWORD *b, BASEWORD *c, size_t siz)
{
	__asm
	{
			mov     ESI, a
			mov     EDI, c
			mov     EBX, b
			sub     EBX, EDI
			mov     ECX, siz
			clc
x:			lodsd
			adc     EAX, [EBX+EDI]
			stosd
			loop    x
			setnge  CL
			neg     ECX
			mov     [EDI], ECX
	}
}

void ImpSubBignums(const BASEWORD *a, const BASEWORD *b, BASEWORD *c, size_t siz)
{
	__asm
	{
		mov     ESI, a
			mov     EDI, c
			mov     EBX, b
			sub     EBX, EDI
			mov     ECX, siz
			clc
x:  lodsd
	sbb     EAX, [EBX+EDI]
		stosd
			loop    x
			setnge  CL
			neg     ECX
			mov     [EDI], ECX
	}
}



void ImpNegBignum(const BASEWORD *a, size_t siz, BASEWORD *c)
{
	__asm
	{
		mov     ESI, a
			mov     EDI, c
			mov     ECX, siz
			clc
x:  lodsd
	mov     EBX, 0
	sbb     EBX, EAX
	xchg    EAX, EBX
	stosd
	loop    x
	setnge  CL
	neg     ECX
	mov     [EDI], ECX
	}
}
*/

/*!!!
void ImpMulBignums(const DWORD *a, DWORD m, const DWORD *b, DWORD n, DWORD *c)
{
memset(c, 0, (m+n)*4);
__asm
{
xor     EDI, EDI
x:  xor     ESI, ESI
xor     ECX, ECX
y:  mov     EBX, a
mov     EAX, [EBX+ESI*4]
mov     EBX, b
mul     DWORD PTR [EBX+EDI*4]
add     EAX, CX
adc     EDX, 
mov     EBX, 
lea     EBX, EBX+ESI*4]
add     [EBX+EDI*4], AX
adc	    EDX, 
mov     ECX, DX
inc     ESI
cmp     ESI, 
jb      y
inc     EDI
mov     [EBX+EDI*4], CX    
cmp     EDI, 
jb      x
}
}*/

/*!!!R
void ImpDivBignums(BASEWORD *a, const BASEWORD *b, BASEWORD *c, size_t n)
{
	DWORD *p = (DWORD*)alloca(n*8),
		*q = p+n;
	memset(p, , *8);
	__asm
	{
		mov     EDX, 
			shl     EDX, 
			mov     ESI, 
			mov     EDI, 
			mov     EBX, 
			clc
x:  mov     ECX, 
	push    EBP
	mov     EBP, 
y:  rcl     DWORD PTR [EBP], 
	inc     EBP
	inc     EBP
	inc     EBP
	inc     EBP
	loop    y
	pop     EBP
	dec     EDX
	mov     ECX, 
	js      t
	push    ESI
z:  rcl     DWORD PTR [ESI], 
	INC     ESI
	INC     ESI
	INC     ESI
	INC     ESI
	loop    z
	pop     ESI
	mov     ECX, 
	push    ESI
	push    EDI
	push    EBX
	clc
w:  lodsd
	sbb     EAX, EBX]
		stosd
			INC     EBX
			INC     EBX
			INC     EBX
			INC     EBX
			loop    w
			pop     EBX
			pop     EDI
			pop     ESI
			cmc
			jnc     x
			xchg    ESI, EDI
			jmp     x
t:  mov     EDI, 
	rep movsd
	}
}
*/

/*!!!
bool ImpRcl(BASEWORD p[], size_t siz)
{
	__asm
	{
		mov			EBX, p
			mov			ECX, siz
			clc
x:	rcl			DWORD PTR [EBX], 1
	INC     EBX
	INC     EBX
	INC     EBX
	INC     EBX
	loop		x
	setc		AL
	}
}
*/

/*!!!R
void ImpShld(const BASEWORD *s, BASEWORD *d, size_t siz, size_t amt)
{
	__asm
	{
		push		EBP
			mov			ESI, s
			mov			EDI, d
			mov			ECX, amt
			mov			EBX, siz
			xor			EBP, EBP
x:		mov			EDX, EBP
		lodsd
		mov			EBP, EAX
		shld		EAX, EDX, CL
		stosd
		dec			EBX
		jnz			x
		xchg		EAX, EBP
		cdq
		shld		EDX, EAX, CL
		mov			[EDI], EDX
		pop			EBP
	}
}

*/

