/*######     Copyright (c) 1997-2012 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com    ##########################################
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published #
# by the Free Software Foundation; either version 3, or (at your option) any later version. This program is distributed in the hope that #
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. #
# See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this #
# program; If not, see <http://www.gnu.org/licenses/>                                                                                    #
########################################################################################################################################*/
#include <el/ext.h>

using namespace Ext;

#if !UCFG_WDM && !UCFG_WCE
#	include <winternl.h>
#endif

#if UCFG_WCE && !UCFG_STDSTL
#	include <windows/ce/corecrtstorage.h>

extern "C" crtEHData* __crt_get_storage_EH();
#endif

#include "ext-os-api.h"

#if UCFG_LIB_DECLS && !defined(_WIN64)
#	pragma comment(lib, "elrt")
#endif

#if UCFG_OS_IMPTLS
#	pragma comment(linker, "/INCLUDE:__tls_used")		//!!! to use our tlssup
#endif


#if UCFG_WDM
#	include "../c-runtime/c-internal.h"

type_info::~type_info() {}

#endif


__BEGIN_DECLS

#if UCFG_WDM
	int _charmax = CHAR_MAX;
	__declspec(dllimport) void __stdcall RtlRaiseException(EXCEPTION_RECORD *er);
	__declspec(dllimport) void _stdcall RtlUnwind (void * TargetFrame, void *TargetIp, PEXCEPTION_RECORD ExceptionRecord, void * ReturnValue);
#endif


void _stdcall API_RaiseException(DWORD dwExceptionCode, DWORD dwExceptionFlags, DWORD nNumberOfArguments, CONST ULONG_PTR *lpArguments) {
#if UCFG_WDM
	EXCEPTION_RECORD er = { dwExceptionCode, dwExceptionFlags, 0, 0, nNumberOfArguments };
	memcpy(er.ExceptionInformation, lpArguments, nNumberOfArguments*sizeof(ULONG_PTR));
	RtlRaiseException(&er);
#else
	RaiseException(dwExceptionCode, dwExceptionFlags, nNumberOfArguments, lpArguments);
#endif
}

#if UCFG_WCE

HRESULT API_SafeArrayGetVartype(SAFEARRAY * psa, VARTYPE * pvt) {
	if (!psa || !pvt)
		return E_INVALIDARG;
	USHORT fFeatures = psa->fFeatures;
	if (!(fFeatures & (FADF_HAVEIID|FADF_HAVEVARTYPE)))
		return E_INVALIDARG;
	if (fFeatures & FADF_RECORD)
		*pvt = VT_RECORD;
	else if (fFeatures & FADF_HAVEIID)
		*pvt = VARTYPE((fFeatures & FADF_DISPATCH) ? VT_DISPATCH : VT_UNKNOWN);
	else
		*pvt = VARTYPE(((DWORD*)psa)[-1]);
	return 0;
}

void __stdcall xxx_RaiseException(DWORD dwExceptionCode, DWORD dwExceptionFlags, DWORD nNumberOfArguments, CONST ULONG_PTR *lpArguments) {
	RaiseException(dwExceptionCode, dwExceptionFlags, nNumberOfArguments, lpArguments);
}

BOOL __stdcall KernelLibIoControl(HANDLE hLib, DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
BOOL __stdcall xxx_KernelLibIoControl(HANDLE hLib, DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned) {
	return KernelLibIoControl(hLib, dwIoControlCode, lpInBuf, nInBufSize, lpOutBuf, nOutBufSize, lpBytesReturned);
}
#endif // UCFG_WCE

#if defined(_M_IX86) && !UCFG_STDSTL

void _stdcall API_RtlUnwind (void * TargetFrame, void *TargetIp, PEXCEPTION_RECORD ExceptionRecord, void * ReturnValue) {
#if UCFG_WDM
	RtlUnwind(TargetFrame, TargetIp, ExceptionRecord, ReturnValue);
#else
	IMP_RtlUnwind(TargetFrame, TargetIp, ExceptionRecord, ReturnValue);
#endif
}

#endif

#ifdef _M_X64

#ifndef UNWIND_HISTORY_TABLE_SIZE
	typedef void *PUNWIND_HISTORY_TABLE;		// defined in new SDK

	extern "C" NTSYSAPI PVOID NTAPI RtlPcToFileHeader(PVOID PcValue, PVOID *BaseOfImage);
	extern "C" VOID NTAPI  RtlUnwindEx (void *TargetFrame, PVOID TargetIp, PEXCEPTION_RECORD ExceptionRecord, PVOID ReturnValue, PCONTEXT OriginalContext, void *HistoryTable);
	extern "C" PVOID WINAPI RtlLookupFunctionEntry(ULONGLONG ControlPC, PULONGLONG ImageBase, void *TargetGp);
#endif


void * _stdcall API_RtlPcToFileHeader(const void *PcValue, void **pBaseOfImage) {
	return RtlPcToFileHeader((void*)PcValue, pBaseOfImage);
}

void _stdcall API_RtlUnwindEx(void *TargetFrame, PVOID TargetIp, PEXCEPTION_RECORD ExceptionRecord, PVOID ReturnValue, PCONTEXT OriginalContext, void *HistoryTable) {
	RtlUnwindEx(TargetFrame, TargetIp, ExceptionRecord, ReturnValue, OriginalContext, (PUNWIND_HISTORY_TABLE)HistoryTable);
}

void * _stdcall API_RtlLookupFunctionEntry(DWORDLONG ControlPC, DWORDLONG *ImageBase, DWORDLONG *TargetGp) {
	return RtlLookupFunctionEntry(ControlPC, ImageBase, (PUNWIND_HISTORY_TABLE)TargetGp);
}

#endif

#if !UCFG_WCE

void * _stdcall API_SetUnhandledExceptionFilter(void *lpTopLevelExceptionFilter) {
#if UCFG_WDM
	Throw(E_FAIL);
#else
	return (LPTOP_LEVEL_EXCEPTION_FILTER )SetUnhandledExceptionFilter((LPTOP_LEVEL_EXCEPTION_FILTER )lpTopLevelExceptionFilter);
#endif
}
#endif

BOOL _stdcall API_IsBadReadPtr(CONST VOID *lp, UINT_PTR ucb) {
#if UCFG_WDM
	return !MmIsAddressValid((void*)lp);
#else
	return IsBadReadPtr(lp, ucb);
#endif
}

BOOL _stdcall API_IsBadWritePtr(VOID *lp, UINT_PTR ucb) {
#if UCFG_WDM
	return !MmIsAddressValid(lp);
#else
	return IsBadWritePtr(lp, ucb);
#endif
}

BOOL _stdcall API_IsBadCodePtr(void *lp) {
#if UCFG_WDM
	return !MmIsAddressValid(lp);
#else
	return IsBadCodePtr((FARPROC)lp);
#endif
}

BOOLEAN _stdcall API_RtlpGetStackLimits(void **stackLimit, void **stackBase) {
#if UCFG_WCE
	const TEB& teb = *(TEB*)(*(byte**)PUserKData - sizeof(TEB));
	*stackLimit = teb.StackBound;
	*stackBase = (byte*)teb.StackBase +teb.ProcStackSize;
#elif defined(WIN32) //!!! was _WIN32
	const NT_TIB& tib = *(NT_TIB*)NtCurrentTeb();
	*stackBase = tib.StackBase;
	*stackLimit = tib.StackLimit;
#else
	Throw(E_NOTIMPL);
#endif;
	const void *sp = &sp;
	return sp >= *stackLimit && sp < *stackBase;
}


#if UCFG_WDM
	PFN_printf g_API_printf = &DbgPrint;
#else
	PFN_printf g_API_printf = (PFN_printf)&printf;
#endif

void _cdecl API_terminate() {
#if UCFG_WDM
	KeBugCheck(123); //!!!
#elif UCFG_WCE
	ExitProcess(3);
#else
	::terminate();
#endif
}

bool _cdecl API_uncaught_exception() {
#if UCFG_STDSTL
	abort(); //!!!
	return false;
#else
	return Ext::ExcRefs::ProcessingThrowRef();
#endif
}


#ifdef _M_IX86

__declspec(dllexport) __declspec(naked) void __cdecl My__ehvec_copy_ctor() {
	_asm  {
		jmp __ehvec_copy_ctor
	}
}

#endif

__END_DECLS



namespace Ext {

#if UCFG_WCE && !UCFG_STDSTL
ExcRefs ExcRefs::GetForCurThread() {
	crtEHData& ehd = *__crt_get_storage_EH();
	return ExcRefs((EHExceptionRecord*&)ehd.CurrentExcept, ehd.ExceptContext);
}

int& ExcRefs::ProcessingThrowRef() {
	return __crt_get_storage_EH()->_ProcessingThrow;
}

#endif

#if UCFG_EXT_C
ExcRefs ExcRefs::GetForCurThread() {
	C_ThreadStorage& ts = C_ThreadStorage::GetForCurThread();
	return ExcRefs(ts.ExceptionRecord, (void*&)ts.Context, ts._translator
#	ifdef _M_X64
	, ts._curexception
	, ts._curcontext
#	endif	
	);
}

int& ExcRefs::ProcessingThrowRef() {
	return C_ThreadStorage::GetForCurThread()._ProcessingThrow;
}


#endif

//!!!vector<HRESULT> g_arIgnoreExceptions;

#if UCFG_EH_SUPPORT_IGNORE
CThreadLocal<CIgnoreList> t_ignoreList;

CLocalIgnore::CLocalIgnore(HRESULT hr) {
	t_ignoreList->IgnoredExceptions.push_front(hr);
}

CLocalIgnore::~CLocalIgnore() {
	t_ignoreList->IgnoredExceptions.pop_front();
}
#endif

void AFXAPI DbgAddIgnoredHResult(HRESULT hr) {
#if UCFG_EH_SUPPORT_IGNORE
	t_ignoreList->IgnoredExceptions.push_front(hr);
#endif
}


bool __stdcall HOOK_SelectFastRaiseException(void* pExceptionObject, void  *_pThrowInfo) {
	DWORD code = *((DWORD*)pExceptionObject+1);
	if ((code & 0xFF000000) == 0x03000000)
		return true;
#if !UCFG_EH_SUPPORT_IGNORE
	return false;
#else
	CIgnoreList::CIgnoredExceptions& ignexs = t_ignoreList->IgnoredExceptions;
	return find(ignexs.begin(), ignexs.end(), code) != ignexs.end();
#endif
}


} // Ext::




