#include <el/ext.h>


class LispIdeApp : public CWinApp {

	CBool m_bSetup, m_bRemove;

	void RunAppEnv() {
		CUnhandledExceptionFilter::I->RestorePrev();

		CDynamicLibrary dll;

		try {
			RegistryKey key(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\AppEnv\\10.0", false);
			String path = key.QueryValue("AppenvStubDLLInstallPath");
			dll.Load(path);
		} catch (RCExc) {
			throw Exc(E_FAIL, "Visual Studio Shell (Isolated mode) not installed");		
		}


		typedef int (__cdecl *PFNStart)(LPSTR, LPWSTR, int, GUID *, WCHAR *pszSettings);
		typedef int (__cdecl *PFNSetup)(LPSTR, LPWSTR, GUID *);
		typedef int (__cdecl *PFNRemove)(LPSTR, LPWSTR);
		
		DlProcWrap<PFNStart> pfnStart(dll, "Start");
		DlProcWrap<PFNSetup> pfnSetup(dll, "Setup");
		DlProcWrap<PFNRemove> pfnRemove(dll, "Remove");
		
		String cmdLine = Environment::CommandLine();
		LPSTR lpCmdLine = (LPSTR)(LPCSTR)cmdLine;

		String appName = m_appName;
		LPWSTR lpwAppName = (LPWSTR)(LPCWSTR)appName;

		int rc;
		if (m_bSetup)
			rc = pfnSetup(lpCmdLine, lpwAppName, 0);
		else if (m_bRemove)
			rc = pfnRemove(lpCmdLine, lpwAppName);
		else
			rc = pfnStart(lpCmdLine, lpwAppName, m_nCmdShow, 0, 0);
		
		Environment::ExitCode = rc;
	}

	BOOL InitInstance() {
		for (int i=0; i<Argc; ++i) {
			String param = Argv[i];
			if (param == "/setup")
				m_bSetup = true;
			else if (param == "/remove")
				m_bRemove = true;
		}
		if (m_bSetup && m_bRemove)
			throw Exc(E_FAIL, "Cannot have bot /setup and /remove options");

		RunAppEnv();
		return FALSE;
	}
} theApp;


